de.esprit.appsuite.io.archive.javatar

## Class TarOutputStream

- java.lang.Object
- - java.io.OutputStream
  - - java.io.FilterOutputStream
    - - de.esprit.appsuite.io.archive.javatar.TarOutputStream

- All Implemented Interfaces:
    java.io.Closeable, java.io.Flushable, java.lang.AutoCloseable
  Direct Known Subclasses:
    TarGzOutputStream

      public class TarOutputStream
      extends java.io.FilterOutputStream

  The TarOutputStream writes a UNIX tar archive as an OutputStream. Methods are provided to put entries, and then write their contents by writing to this stream using write(). Kerry Menzel Contributed the code to support file sizes greater than 2GB (longs versus ints).
  Version:
    $Revision: 1.1 $
  Author:
    Timothy Gerard Endres,
  See Also:
    `TarBuffer`, `TarHeader`, `TarEntry`

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected byte[]` | `assemBuf`
    `protected int` | `assemLen`
    `protected TarBuffer` | `buffer`
    `protected long` | `currBytes`
    `protected long` | `currSize`
    `protected boolean` | `debug`
    `protected byte[]` | `oneBuf`
    `protected byte[]` | `recordBuf`

    - ### Fields inherited from class java.io.FilterOutputStream

      `out`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `TarOutputStream(java.io.OutputStream os)`
    `TarOutputStream(java.io.OutputStream os, int blockSize)`
    `TarOutputStream(java.io.OutputStream os, int blockSize, int recordSize)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close()` Ends the TAR archive and closes the underlying OutputStream.
    `void` | `closeEntry()` Close an entry.
    `void` | `finish()` Ends the TAR archive without closing the underlying OutputStream.
    `int` | `getRecordSize()` Get the record size being used by this stream's TarBuffer.
    `void` | `putNextEntry(TarEntry entry)` Put an entry on the output stream.
    `void` | `setBufferDebug(boolean isDebug)` Sets the debugging flag in this stream's TarBuffer.
    `void` | `setDebug(boolean isDebug)` Sets the debugging flag.
    `void` | `write(byte[] wBuf)` Writes bytes to the current tar archive entry.
    `void` | `write(byte[] wBuf, int wOffset, int numToWrite)` Writes bytes to the current tar archive entry.
    `void` | `write(int b)` Writes a byte to the current tar archive entry.

    - ### Methods inherited from class java.io.FilterOutputStream

      `flush`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### debug

          protected boolean debug

    - #### currSize

          protected long currSize

    - #### currBytes

          protected long currBytes

    - #### oneBuf

          protected byte[] oneBuf

    - #### recordBuf

          protected byte[] recordBuf

    - #### assemLen

          protected int assemLen

    - #### assemBuf

          protected byte[] assemBuf

    - #### buffer

          protected TarBuffer buffer

  - ### Constructor Detail

    - #### TarOutputStream

          public TarOutputStream(java.io.OutputStream os)

    - #### TarOutputStream

          public TarOutputStream(java.io.OutputStream os,
                         int blockSize)

    - #### TarOutputStream

          public TarOutputStream(java.io.OutputStream os,
                         int blockSize,
                         int recordSize)

  - ### Method Detail

    - #### setDebug

          public void setDebug(boolean isDebug)

      Sets the debugging flag.
      Parameters:
        `isDebug` - True to turn on debugging.

    - #### setBufferDebug

          public void setBufferDebug(boolean isDebug)

      Sets the debugging flag in this stream's TarBuffer.
      Parameters:
        `isDebug` - True to turn on debugging.

    - #### finish

          public void finish()
                      throws java.io.IOException

      Ends the TAR archive without closing the underlying OutputStream. The result is that the EOF record of nulls is written.
      Throws:
        `java.io.IOException`

    - #### close

          public void close()
                     throws java.io.IOException

      Ends the TAR archive and closes the underlying OutputStream. This means that finish() is called followed by calling the TarBuffer's close().
      Specified by:
        `close` in interface `java.io.Closeable`
      Specified by:
        `close` in interface `java.lang.AutoCloseable`
      Overrides:
        `close` in class `java.io.FilterOutputStream`
      Throws:
        `java.io.IOException`

    - #### getRecordSize

          public int getRecordSize()

      Get the record size being used by this stream's TarBuffer.
      Returns:
        The TarBuffer record size.

    - #### putNextEntry

          public void putNextEntry(TarEntry entry)
                            throws java.io.IOException

      Put an entry on the output stream. This writes the entry's header record and positions the output stream for writing the contents of the entry. Once this method is called, the stream is ready for calls to write() to write the entry's contents. Once the contents are written, closeEntry() MUST be called to ensure that all buffered data is completely written to the output stream.
      Parameters:
        `entry` - The TarEntry to be written to the archive.
      Throws:
        `java.io.IOException`

    - #### closeEntry

          public void closeEntry()
                          throws java.io.IOException

      Close an entry. This method MUST be called for all file entries that contain data. The reason is that we must buffer data written to the stream in order to satisfy the buffer's record based writes. Thus, there may be data fragments still being assembled that must be written to the output stream before this entry is closed and the next entry written.
      Throws:
        `java.io.IOException`

    - #### write

          public void write(int b)
                     throws java.io.IOException

      Writes a byte to the current tar archive entry. This method simply calls read( byte[], int, int ).
      Overrides:
        `write` in class `java.io.FilterOutputStream`
      Parameters:
        `b` - The byte written.
      Throws:
        `java.io.IOException`

    - #### write

          public void write(byte[] wBuf)
                     throws java.io.IOException

      Writes bytes to the current tar archive entry. This method simply calls read(byte[], int, int ).
      Overrides:
        `write` in class `java.io.FilterOutputStream`
      Parameters:
        `wBuf` - The buffer to write to the archive.
      Throws:
        `java.io.IOException`

    - #### write

          public void write(byte[] wBuf,
                   int wOffset,
                   int numToWrite)
                     throws java.io.IOException

      Writes bytes to the current tar archive entry. This method is aware of the current entry and will throw an exception if you attempt to write bytes past the length specified for the current entry. The method is also (painfully) aware of the record buffering required by TarBuffer, and manages buffers that are not a multiple of record size in length, including assembling records from small buffers. This method simply calls read( byte[], int, int ).
      Overrides:
        `write` in class `java.io.FilterOutputStream`
      Parameters:
        `wBuf` - The buffer to write to the archive.
        `wOffset` - The offset in the buffer from which to get bytes.
        `numToWrite` - The number of bytes to write.
      Throws:
        `java.io.IOException`

Copyright © 2014 EsprIT-Systems. All Rights Reserved.